## mupdf 1.7

=== debian/changelog ===
mupdf (1.7-1mx150+1) mx; urgency=low

  * Rebuild for MX 15.
 
 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Wed, 10 Jun 2015 11:10:30 -0700

mupdf (1.7-1) unstable; urgency=medium

  * New Upstream version 1.7
    + Added missing section in mutool man page. (Closes: #775427)
    + Set _NET_WM_NAME properly. (Closes: #780019)
    + Support continuously scrolling. (Closes: #611221)
    + "mutool clean" now has correct exit status. (Closes: #781746)
  * Refresh patches
  * Remove generated file in clean target
  * debian/control: Add that MuPDF also reads XPS, OpenXPS and ePub.
  * debian/watch: Use repacksuffix and dversionmangle
  * Move mupdf-x11 out of /usr/bin.
    Thanks to Mathieu Malaterre for the patch (Closes: #752207)
  * debian/patches/0008-Bigger-scaling.patch: Add more scale level.
    Thanks to Thomas Prokosch for the patch (Closes: #769282)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 07 May 2015 00:03:39 +0800
