=== debian/changelog ===
mupdf (1.7a-1) unstable; urgency=high

  * New Upstream version 1.7a
  * debian/rules: Fix FTBFS with new libjbig2. (Closes: #796420)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Fri, 18 Sep 2015 23:14:20 +0800
