=== debian/control ===
--- 
+++ 
@@ -1,9 +1,7 @@
 Source: mupdf
 Section: text
 Priority: optional
-Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
-Bugs: mailto: maintainer@mepiscommunity.org
-XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
+Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
 Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1.1~),
  libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
@@ -19,7 +17,7 @@
 Depends: ${misc:Depends}
 Description: development files for the MuPDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
- It also reads XPS, OpenXPS, CBZ and ePub documents.
+ It also reads XPS, OpenXPS and ePub documents.
  .
  This package contains the static library and headers.
 
@@ -30,7 +28,7 @@
 Provides: pdf-viewer
 Description: lightweight PDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
- It also reads XPS, OpenXPS, CBZ and ePub documents.
+ It also reads XPS, OpenXPS and ePub documents.
  .
  The renderer in MuPDF is tailored for high quality anti-aliased graphics.
  It renders text with metrics and spacing accurate to within fractions of a
@@ -42,7 +40,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: commmand line tools for the MuPDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
- It also reads XPS, OpenXPS, CBZ and ePub documents.
+ It also reads XPS, OpenXPS and ePub documents.
  .
  This package contains command line tools using the MuPDF library:
   - mutool - tool for clean, extract, inspect PDF documents.
