=== debian/changelog ===
mupdf (1.9a+ds1-4+deb9u4) stretch-security; urgency=high

  * Fix CVE-2017-17866, CVE-2018-1000037, CVE-2018-1000040, CVE-2018-5686,
    CVE-2018-6187, and CVE-2018-6192
    (Closes: #885120, #887130, #888464, #888487)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 28 Oct 2018 18:14:58 +0900

mupdf (1.9a+ds1-4+deb9u3) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * CVE-2018-6544, CVE-2018-1000051
    add patches to fix use after free (Closes: #891245)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 24 Mar 2018 19:03:02 +0100

mupdf (1.9a+ds1-4+deb9u2) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * A compiler optimization was removing the fix for CVE-2017-15587 

 -- Luciano Bello <luciano@debian.org>  Fri, 10 Nov 2017 14:58:10 -0500

mupdf (1.9a+ds1-4+deb9u1) stable-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Fix CVE-2017-14685, CVE-2017-14686, CVE-2017-14687, and CVE-2017-15587
    (Closes: #877379, #879055)

 -- Luciano Bello <luciano@debian.org>  Sun, 22 Oct 2017 20:10:29 -0400

mupdf (1.9a+ds1-4) unstable; urgency=high

  * Fix patch for CVE-2017-5991: The original patch was incomplete.
    (Closes: #855383)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 18 Feb 2017 00:43:12 +0800

mupdf (1.9a+ds1-3) unstable; urgency=high

  * CVE-2017-5896: use-after-free in fz_subsample_pixmap()  (Closes: #854734)
  * CVE-2017-5991: NULL pointer dereference in pdf_run_xobject()

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 16 Feb 2017 23:43:55 +0800

mupdf (1.9a+ds1-2) unstable; urgency=medium

  * Acknowledge NMU.
  * CVE-2016-8674: heap-use-after-free in pdf_to_num (pdf-object.c)
    (Closes: #840957)
  * Set debhelper compact to 9

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 15 Nov 2016 00:07:55 +0800

mupdf (1.9a+ds1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * CVE-2016-6525: heap overflow in pdf_load_mesh_params() (Closes: #833417)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 06 Aug 2016 13:44:07 +0200

mupdf (1.9a+ds1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * CVE-2016-6265: Use after free vulnerability in pdf_xref.c
    (Closes: #832031)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 01 Aug 2016 14:17:20 +0200

mupdf (1.9a+ds1-1) unstable; urgency=medium

  * New upstream release (Closes: #819101)
  * Add glfw and harfbuzz third party libraries to Files-Excluded
  * Building now requires libharfbuzz-dev
  * Drop patches included in upstream release
  * Disable mupdf to read from console. (Closes: #830143)
  * The mudraw command is merged to mutool
  * Update debian/watch to reflect new download page structure
  * Fix typo in debian/control
  * Use --uscan with gbp import-orig by default
  * Support more options in the wrapper (Closes: #819099)
  * Bump Standards-Version to 3.9.8, no changes needed

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 07 Jul 2016 01:58:00 +0800
