=== debian/control ===
--- 
+++ 
@@ -5,8 +5,9 @@
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
 Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1.1~),
  libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
- libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev
-Standards-Version: 3.9.6
+ libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
+ libharfbuzz-dev
+Standards-Version: 3.9.8
 Homepage: http://mupdf.com/
 Vcs-Git: git://git.debian.org/git/users/koster/mupdf.git
 Vcs-Browser: http://git.debian.org/?p=users/koster/mupdf.git;a=summary
@@ -38,10 +39,10 @@
 Package: mupdf-tools
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: commmand line tools for the MuPDF viewer
+Description: command line tools for the MuPDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
  It also reads XPS, OpenXPS and ePub documents.
  .
  This package contains command line tools using the MuPDF library:
-  - mutool - tool for clean, extract, inspect PDF documents.
-  - mudraw - render PDF/XPS/CBZ documents.
+  - mutool - tool for clean, extract, inspect PDF documents and
+             render PDF/XPS/CBZ documents.
