## mupdf 1.11+ds1

=== debian/changelog ===
mupdf (1.11+ds1-2) unstable; urgency=high

  * Acknowledge NMU. Thanks, Salvatore.
  * Renumber patches
  * Fixes CVE-2017-15587 (Closes: 879055)
  * Sort files in static library to make the build reproducible.
  * Bump Standards-Version to 4.1.1. No changes needed.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 26 Oct 2017 22:28:43 +0800

mupdf (1.11+ds1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Don't use xps font if it could not be loaded (CVE-2017-14685)
    (Closes: #877379)
  * Check name, comment and meta size field signs (CVE-2017-14686)
    (Closes: #877379)
  * Handle non-tags in tag name comparisons (CVE-2017-14687) (Closes: #877379)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 08 Oct 2017 10:37:23 +0200

mupdf (1.11+ds1-1) unstable; urgency=medium

  * New upstream version 1.11+ds1
    (Closes: #702479, #868821, #868822, #868052)
  * Refresh patches
  * debian/copyright: thirdparty/jpeg renamed to thirdparty/libjpeg
  * Bump Standards-Version to 4.1.0. No changes needed.
  * debian/copyright: Update copyright information for font resources
  * debian/mupdf.sh: handle double-dash shell opts (Closes: #851942)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 24 Sep 2017 14:56:00 +0800
