=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
  libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
  libharfbuzz-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://mupdf.com/
 Vcs-Git: git://git.debian.org/git/users/koster/mupdf.git
 Vcs-Browser: http://git.debian.org/?p=users/koster/mupdf.git;a=summary
